<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output indent="yes" method="xml"/>
	<xsl:param name="obsoleteProductsFilename"/>
  <xsl:variable name="obsoleteProducts" select="document($obsoleteProductsFilename)"/>
  <xsl:key name="products-by-nameversion" match="product" use="concat(@name, '-', @version)"/>
  
  <xsl:template match="/">
     <xsl:processing-instruction name="xml-stylesheet">
       <xsl:text>type="text/xsl" </xsl:text>
       <xsl:text>href="repository_renderer.xsl"</xsl:text>
     </xsl:processing-instruction>
     <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="*">
    <xsl:copy>
      <xsl:copy-of select="@*"/>
      <xsl:apply-templates/>
    </xsl:copy>
  </xsl:template>

  <xsl:template match="product">
    <xsl:variable name="name" select="@name"/>
    <xsl:variable name="version" select="@version"/>
    <xsl:choose>
	    <xsl:when test="$obsoleteProducts/products/product[@name = $name and @version = $version]"/>
	    <xsl:otherwise>
		    <xsl:copy>
		      <xsl:copy-of select="@*"/>
		      <xsl:apply-templates/>
		    </xsl:copy>
	    </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:stylesheet>
