/*
 * Resources.java
 * 
 * Created on February 17, 2004, 8:53 PM
 */

package cern.jjar.resources;

import javax.xml.transform.Templates;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamSource;

/**
 * @author gkruk
 */
public class Resources {

  private static final String FILTER_TRANSFORM = "filter-product.xsl";
  private static final String REGISTER_TRANSFORM = "register-product.xsl";
  private static final String RELEASE_TRANSFORM = "release-product.xsl";
  private static final String UNREGISTER_TRANSFORM = "unregister-product.xsl";
  private static final String UPDATE_VERSION_TRANSFORM = "update-version.xsl";
  private static final String VERSION_PRODUCT_TRANSFORM = "version-product.xsl";
  
  /** Creates a new instance of Resources */
  private Resources() {}
 
  public static Templates getUnregisterProductTemplate() throws TransformerConfigurationException {
    return getTemplate(UNREGISTER_TRANSFORM);
  }
  
  public static Templates getFilterProductTemplate() throws TransformerConfigurationException {
    return getTemplate(FILTER_TRANSFORM);
  }
  
  public static Templates getReleaseProductTemplate() throws TransformerConfigurationException {
    return getTemplate(RELEASE_TRANSFORM);
  }
  
  public static Templates getRegisterProductTemplate() throws TransformerConfigurationException {
    return getTemplate(REGISTER_TRANSFORM);
  }
  
  public static Templates getUpdateVersionTemplate() throws TransformerConfigurationException {
    return getTemplate(UPDATE_VERSION_TRANSFORM);
  }
  
  public static Templates getVersionProductTemplate() throws TransformerConfigurationException {
    return getTemplate(VERSION_PRODUCT_TRANSFORM);
  }
  
  private static Templates getTemplate(String templateName) throws TransformerConfigurationException {
    TransformerFactory tf = TransformerFactory.newInstance();
    Templates templates = tf.newTemplates(new StreamSource(Resources.class.getResourceAsStream(templateName)));
    return templates;
  }
  
}