/*
 * $Id $
 * 
 * $Date: 2006/05/15 14:49:26 $ $Revision: 1.3 $ $Author: lmestre $
 * 
 * Copyright CERN, All Rights Reserved.
 */
package cern.jjar;

import java.io.File;

import cern.jjar.runner.JJarRunner;
import cern.jjar.runner.ProductVersionerRunner;

/**
 * An ant task for placing  an explicit version in the local descriptor for all dependencies.
 * 
 * Parameters:
 * <ul>
 * <li><i>localdescriptor</i> - path to the file on the local disc (e.g.: * c:/projects/bic/product.xml)</li>
 * <li><i>alias</i> - the default alias to use when no version is specified
 * </li>
 * </ul>
 * 
 * @author Lionel Mestre
 * @version $Id: ProductVersionerTask.java,v 1.3 2006/05/15 14:49:26 lmestre Exp $
 */
public class ProductVersionerTask extends AbstractJJarTask {

  /* Local descriptor file */
  private File localdescriptor;
  protected String defaultdependencyversion = "PRO";

  private boolean resolvealias;

  //
  // -- CONSTRUCTORS -----------------------------------------------
  //

  public ProductVersionerTask() {}

  //
  // -- PUBLIC METHODS -----------------------------------------------
  //

  public final void setResolvealias(boolean resolvealias) {
    this.resolvealias = resolvealias;
  }

  public void setLocaldescriptor(File localdescriptor) {
    this.localdescriptor = localdescriptor;
  }
  
  public final void setDefaultdependencyversion(String defaultdependencyversion) {
    this.defaultdependencyversion = defaultdependencyversion;
  }

  protected JJarRunner createRunner() {
    ProductVersionerRunner runner = new ProductVersionerRunner(this);
    runner.setLocaldescriptor(localdescriptor);
    runner.setDefaultdependencyversion(defaultdependencyversion);
    runner.setResolvealias(resolvealias);
    runner.setRepositoryElements(getRepositoryElements());
    return runner;
  }
  
  protected void processResult(Object result) {
  }

}
