/*
 * $Id $
 * 
 * $Date: 2005/01/10 08:15:59 $ $Revision: 1.3 $ $Author: lmestre $
 * 
 * Copyright CERN, All Rights Reserved.
 */
package cern.jjar;

import cern.jjar.runner.JJarRunner;
import cern.jjar.runner.UnregisterRunner;

/**
 *  -<b>unregister</b>- Removes from the production repository record about
 * given version of a product. Parameters:
 * <ul>
 * <li><i>repository</i>- URL of the production repository.
 * <li><i>product</i>- Name of the product.
 * <li><i>version</i>- Version of product mentioned above. It has to be numbered version (1.0, 2.0.4, ...)
 * </ul>
 * 
 * @author Lionel Mestre
 * @author Grzegorz Kruk
 * @version $Id: UnregisterTask.java,v 1.3 2005/01/10 08:15:59 lmestre Exp $
 */
public class UnregisterTask extends AbstractJJarTask {

  /* Name of the product */
  private String product;

  /* Version of the product */
  private String version;

  //
  // -- CONSTRUCTORS -----------------------------------------------
  //

  public UnregisterTask() {}

  //
  // -- PUBLIC METHODS -----------------------------------------------
  //

  public void setProduct(String product) {
    this.product = product;
  }

  public void setVersion(String version) {
    this.version = version;
  }

  //
  // -- PROTECTED METHODS -----------------------------------------------
  //

  protected JJarRunner createRunner() {
    UnregisterRunner runner = new UnregisterRunner(this);
    runner.setProduct(product);
    runner.setRepositoryElements(getRepositoryElements());
    runner.setVersion(version);
    return runner;
  }
  
  protected void processResult(Object result) {
  }
  
}
