package cern.jjar.runner;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import sun.security.action.GetLongAction;

import cern.jjar.repository.Repository;

public class StatisticsRunner extends AbstractJJarRunner{
    
    private int totalCounter = 0;
    private int productCounter = 0;
    
    public StatisticsRunner(){
        super();
    }
    
    public Object run(){
        Repository repository = lookupRepository();
        Document document = repository.getDocument();
        
        calculateNOProducts(document);
        printStats();
        return null;
    }
    
    
    private void printStats(){
        
        
        System.out.println("===== Production repostitory statistics =====");
        System.out.println("Number of product: "+ productCounter);
        System.out.println("Number of artifacts in total: " + totalCounter);
    }
    
    
    private void calculateNOProducts(Document document){
        Element root = document.getDocumentElement();
        XPath xpath = XPathFactory.newInstance().newXPath();

        Set productSet = new HashSet();

        String expression = "//product";
        NodeList list = findNodeList(xpath, root, expression);
        totalCounter = list.getLength();
        for(int i=0; i<list.getLength(); i++){
            Node currentNode = list.item(i);
            String prodName = ((Element)currentNode).getAttribute("name");
            productSet.add(prodName);
            
        }
        String[] products = (String[]) productSet.toArray(new String[productSet.size()]);
        Arrays.sort(products);

        for (int i=0; i<products.length; i++) {
            System.out.println(products[i]);
        }
        productCounter = productSet.size();
    }
    
    protected Element findNode(XPath xpath, Element root, String expression) {

        try {
          Element element = (Element) xpath.evaluate(expression, root, XPathConstants.NODE);
          return element;
        } catch (XPathExpressionException xpex) {
          xpex.printStackTrace();
          System.out.println("xpath failed");
        } catch (Exception ex) {
          ex.printStackTrace();
        }
        return null;
    }
    
    protected NodeList findNodeList(XPath xpath, Element root, String expression) {

        try {
          NodeList nodeList = (NodeList) xpath.evaluate(expression, root, XPathConstants.NODESET);
          return nodeList;
        } catch (XPathExpressionException xpex) {
          xpex.printStackTrace();
          System.out.println("xpath failed");
        } catch (Exception ex) {
          ex.printStackTrace();
        }
        return null;
    }
    
    
    public static void main(String[] args){
        
        StatisticsRunner runner = new StatisticsRunner();
        runner.setRepositoryElements(
                new RepositoryElement[]{new RepositoryElement("file://C:\\repositoryXML\\pro\\feb")});
        runner.run();
        
    }
}