package release.notification.anttasks;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import release.notification.SubscriptionHandler;



public class GetSubscribers extends SubscriptionHandler{
    
    private String productName;
    
    public GetSubscribers(){
        super();
    }
    
    //productName may be a comma-separated string of several products
    public void setProductName(String productName){
        this.productName = productName;
    }
    
    public Object run(){
        String[] products = productName.split(",");
        Set subscribers = new HashSet();
        
        for(int i=0; i<products.length; i++){
            subscribers.addAll(getSubscribers(products[i]));
        }
        System.out.println(subscribers.toString());
        
        return subscribers;
    }
    
    
    private Collection getSubscribers(String product){
        ArrayList emails = new ArrayList();
        Element root = document.getDocumentElement();
        String expression;
        NodeList nodeList;
        XPath xpath = XPathFactory.newInstance().newXPath();
        
        expression = "/subscriptions/product[@name=\"" +product.trim()+ "\"]/subscribers/sub";
        nodeList = findNodeList(xpath, root, expression);
        
        for(int i=0; i<nodeList.getLength(); i++){
            String value = ((Element)nodeList.item(i)).getAttribute("email");
            emails.add(value);
        }
        return emails;
    }
    
    public static void main(String[] args){
        
        GetSubscribers getSubs = new GetSubscribers();
        getSubs.setProductName("lin-vistar");
        getSubs.run();
        
    }
   
}