package release.notification.anttasks;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import org.apache.tools.ant.Task;


public class GetSubscribersTask extends Task{
    
    private String productname; 
    
    private static final String NO_SUBSCRIBERS_REGISTERED = "empty";
    private static final String SUBSCRIBERS = "release.notification.subscribers";
    
    public GetSubscribersTask(){}
    
    public void setProductname(String productname){
        this.productname = productname;
    }
    
    
    public void execute(){
        GetSubscribers getSubs = new GetSubscribers();
        getSubs.setProductName(productname);
        
        processResult(getSubs.run());
    }
    
    private void processResult(Object result){
        final Set resultSet = (HashSet) result;
        String concatenatedString = "";
        
        for (Iterator iter = resultSet.iterator(); iter.hasNext();) {
            if (!"".equals(concatenatedString)){
                concatenatedString = concatenatedString + ", ";
              }
              concatenatedString = concatenatedString + "" + (String) iter.next();
        }
        if("".equals(concatenatedString)){
            concatenatedString = NO_SUBSCRIBERS_REGISTERED;
        }
        
        getProject().setNewProperty(SUBSCRIBERS, concatenatedString);
    }
    
}