package release.notification.javabeans;

import java.io.File;

import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Element;

import release.notification.SubscriptionHandler;


public class RegisterSubscription extends SubscriptionHandler{
    
    public String[] productstosubscribe;
    public String subscriber;
    public String result;
    
    
    public RegisterSubscription(){
        super();
    }
    
    public void setProductstosubscribe(String[] products){
        productstosubscribe = products;
    }
    
    public String[] getProductstosubscribe(){
        return productstosubscribe;
    }
    
    public void setSubscriber(String email){
        subscriber = processEmail(email);
    }
    
    public String getSubscriber(){
        return subscriber;
    }
    
    public boolean updateSubscriptionFile() throws Exception{
        
        if(!inputsVerified(subscriber, productstosubscribe) || "*".equals(subscriber)){
            return false;
        }
        
        Element root = document.getDocumentElement();
        String expression;
        Element element;
        XPath xpath = XPathFactory.newInstance().newXPath();
        
        for(int i=0;i<productstosubscribe.length;i++){
            
            expression = "/subscriptions/product[@name=\"" + productstosubscribe[i] + "\"]/subscribers/sub[@email=\"" +subscriber+ "\"]";
            element = findNode(xpath, root, expression);
            if (element == null){
                String expr = "/subscriptions/product[@name=\"" + productstosubscribe[i] + "\"]/subscribers";
                Element el = findNode(xpath, root, expr);
                if(el != null){
                    Element newSubEl = document.createElement("sub");
                    newSubEl.setAttribute("email", subscriber);
                    el.appendChild(newSubEl);
                }else{
                    Element prodEl = document.createElement("product");
                    prodEl.setAttribute("name", productstosubscribe[i]);
                    Element subScriptEl = document.createElement("subscribers");
                    Element newSubEl = document.createElement("sub");
                    newSubEl.setAttribute("email", subscriber);
                    subScriptEl.appendChild(newSubEl);
                    prodEl.appendChild(subScriptEl);
                    root.appendChild(prodEl);
                }
            }
        }
        saveSubscriptionFile(document, new File(SUB_DIR));
        
        return true;
    }
    
   public static void main(String[] args){
        
        RegisterSubscription registerSub = new RegisterSubscription();
        registerSub.setProductstosubscribe(new String[]{"logging-data-accessor-api"});
        registerSub.setSubscriber("gunnar@cern.ch");
        try{
            registerSub.updateSubscriptionFile();
        }catch(Exception ex){
            System.out.println("her skjer feilen");
            ex.printStackTrace();
        }
    }
    
}