package release.notification;

import java.io.File;
import java.net.URL;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;

import release.notification.parsers.NotificationSAXParser;


public class RepositoryHandler extends DefaultHandler{
    
    //private String xmlInput;
    public Set productsFound = new HashSet();
    public NotificationSAXParser saxParser;
    
    public RepositoryHandler(URL xmlInput) throws Exception{
        saxParser = new NotificationSAXParser(xmlInput, this);
    }
    
    public RepositoryHandler(File xmlInput) throws Exception{
        saxParser = new NotificationSAXParser(xmlInput, this);
    }
    
    public void endElement(java.lang.String uri, java.lang.String localName, java.lang.String qName){
      //  System.out.println(qName);
    }
    
    public void startElement(java.lang.String uri, java.lang.String localName, java.lang.String qName,
            Attributes atts){
        
        if(localName.endsWith("product")){
            productsFound.add(atts.getValue("name"));
        }
    }
    
    public void printProducts(){
        
        System.out.println(productsFound.size());
        for (Iterator iter = productsFound.iterator(); iter.hasNext();) {
            String element = (String) iter.next();
            System.out.println(element.toString());
        }
    }
    
    public Set getProducts(){
        return productsFound;
    }

    public static void main(String[] args){
        
        try{
            RepositoryHandler testParser = new RepositoryHandler(new URL("http://slwww.cern.ch/~pcrops/releaseinfo/pcropsdist/repository.xml"));
            testParser.printProducts();
        }catch(Exception ex){
            System.out.println("problem occured while parsing the repository-desctriptor");
        }
    }
}