package release.notification.javabeans;

import java.io.File;
import java.io.Serializable;
import java.net.URL;
import java.util.Arrays;
import java.util.Set;

import release.notification.PropertiesHandler;
import release.notification.RepositoryHandler;

public class GetRepositoryProducts implements Serializable{
    
    public RepositoryHandler repositoryParser;
    public String[] productList;
    
    protected static final String REPOSITORY_DESC_DIR = PropertiesHandler.getInstance().loadPropetry("repository.descriptor.dir");
    protected static final String REPOSITORY_DESC_FILE_NAME = PropertiesHandler.getInstance().loadPropetry("repository.descriptor.filename");
    
    public GetRepositoryProducts(){
        String repDesc = REPOSITORY_DESC_DIR + REPOSITORY_DESC_FILE_NAME;
        System.out.println(repDesc);
        try{
            repositoryParser = new RepositoryHandler(new URL(repDesc));
        }catch(Exception ex){
            System.out.println("Problems while parsing the repository-descriptor");
        }
        productList = getProductlist();
    }
    
    public String[] getProductlist(){
        Set tmpSet = repositoryParser.getProducts();
        String[] tmpArray = (String[]) tmpSet.toArray(new String[tmpSet.size()]);
        Arrays.sort(tmpArray);
        return tmpArray;
    }
    
    public static void main(String[] args){
        
        GetRepositoryProducts repHandler = new GetRepositoryProducts();
        String[] products = repHandler.getProductlist();
        System.out.println("----------------");
        for (int i = 0; i < products.length; i++) {
            System.out.println(products[i]);
        }
    }
}