package release.notification.javabeans;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import release.notification.SubscriptionHandler;


public class GetSubscription extends SubscriptionHandler{
    
    public String[] subscriptionList; 
    public String subscriber;
    
    public GetSubscription(){
        super();
    }
    
    public void setSubscriber(String email){
        subscriber = processEmail(email);
    }
    
    public String getSubscriber(){
        return subscriber;
    }
    
    public String[] getSubscriptionList() throws Exception{
        
        if(!verifyEmail(subscriber)){
            return null;
        }

        if("*".equals(subscriber)){
            
            return getAllSubscriptions();
        }else{
            Set tmpSet = getSubscriptions();
            String[] tmpArray = (String[]) tmpSet.toArray(new String[tmpSet.size()]);
            Arrays.sort(tmpArray);
            return tmpArray;
        }
    }

    private String[] getAllSubscriptions(){
        
        Map productList = new HashMap();
        Element root = document.getDocumentElement();
        String expression;
        NodeList nodeList;
        XPath xpath = XPathFactory.newInstance().newXPath();
        
        expression = "//sub";
        nodeList = findNodeList(xpath, root, expression);
        for(int i=0; i<nodeList.getLength(); i++){
            Node currentNode = nodeList.item(i);
            String subscriber = ((Element)currentNode).getAttribute("email");
            String product = currentNode.getParentNode().getParentNode().getAttributes().item(0).getNodeValue();
            
            if(!productList.containsKey(subscriber)){
                ArrayList subscriptions = new ArrayList();
                subscriptions.add(product);
                productList.put(subscriber, subscriptions);
            }else{
                ArrayList subscriptions = (ArrayList) productList.get(subscriber);
                subscriptions.add(product);
                productList.put(subscriber, subscriptions);
            }
            System.out.println(i +": " + subscriber + " subscribing to " + product);
        }
        
        Set keySet = productList.keySet();
        String[] tmpArray = (String[]) keySet.toArray(new String[keySet.size()]);
        Arrays.sort(tmpArray);
        
        
        ArrayList finalList = new ArrayList();
        for(int i=0; i<tmpArray.length; i++ ){
            finalList.add("=== "+tmpArray[i]+" ===");
            finalList.addAll((ArrayList)productList.get(tmpArray[i]));
            finalList.add("");
        }
        
        //System.out.println(productList);
        System.out.println(finalList);
        
        return (String[])finalList.toArray(new String[finalList.size()]);
    }
    
    private Set getSubscriptions() throws Exception{
        
        Set productList = new HashSet();
        Element root = document.getDocumentElement();
        String expression;
        NodeList nodeList;
        XPath xpath = XPathFactory.newInstance().newXPath();
        
        expression = "//sub[@email=\"" +subscriber+ "\"]";
        nodeList = findNodeList(xpath, root, expression);
        for(int i=0; i<nodeList.getLength(); i++){
            String value = nodeList.item(i).getParentNode().getParentNode().getAttributes().item(0).getNodeValue();
            productList.add(value);
            System.out.println(i +": "+value);
        }
        
        return productList;
    }
    
    public static void main(String[] args){
        
        GetSubscription showSub = new GetSubscription();
        showSub.setSubscriber("*");
        try{
            //showSub.emailVerified("enes@cern.ch");
            showSub.getSubscriptionList();
        }catch(Exception ex){
            System.out.println("her skjer feilen");
            ex.printStackTrace();
        }
    }
    
}