package release.notification.javabeans;

import java.io.File;

import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import release.notification.SubscriptionHandler;


public class RemoveSubscription extends SubscriptionHandler{
    
    public String[] productstounsubscribe;
    public String subscriber;
    
    public RemoveSubscription(){
        super();
    }
    
    public void setProductstounsubscribe(String[] products){
        productstounsubscribe = products;
    }
    
    public String[] getProductstounsubscribe(){
        return productstounsubscribe;
    }
    
    public void setSubscriber(String email){
        subscriber = processEmail(email);
    }
    
    public String getSubscriber(){
        return subscriber;
    }
    
    public boolean removeSubscription() throws Exception{
        
        if(!inputsVerified(subscriber, productstounsubscribe)){
            return false;
        }
        
        Element root = document.getDocumentElement();
        String expression;
        Element element;
        XPath xpath = XPathFactory.newInstance().newXPath();
        
        for(int i=0; i<productstounsubscribe.length; i++){
            expression = "/subscriptions/product[@name=\""+ productstounsubscribe[i] +"\"]/subscribers/sub[@email=\""+ subscriber +"\"]";
            element = findNode(xpath, root, expression);
            if(element != null){
                Element parent = (Element)element.getParentNode();
                parent.removeChild(element);

                if(!parent.hasChildNodes()){
                    Element parentsparent = (Element) parent.getParentNode();
                    root.removeChild(parentsparent);
                }
            }
        }
        saveSubscriptionFile(document, new File(SUB_DIR));
        return true;
    }
    
    public static void main(String[] args){
        
        RemoveSubscription removeSub = new RemoveSubscription();
        removeSub.setSubscriber("enes@cern.ch");
        removeSub.setProductstounsubscribe(new String[]{"lhc-ti8-logging"});
        try{
            removeSub.removeSubscription();
        }catch(Exception ex){
            System.out.println("error removing the subsciption");
            ex.printStackTrace();
        }
    }
}