package release.notification.parsers;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;

public class NotificationDOMParser{
    
    public Document document;
    
    public NotificationDOMParser(URL url) throws IOException {
        this(url.openStream());
    }

    public NotificationDOMParser(File file) throws IOException {
        this(new FileInputStream(file));
    }

    public NotificationDOMParser(InputStream inputStream) throws IOException {
        document = parse(inputStream);
    }
    
    /**
     * @param inputStream
     * @return
     * @throws IOException
     */
    private Document parse(InputStream inputStream) throws IOException {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        factory.setValidating(true);
        try{
            factory.setIgnoringElementContentWhitespace(true);
            //factory.setFeature("http://apache.org/xml/features/dom/include-ignorable-whitespace", false);
        }catch(Exception ex){
            System.out.println("setFeature error");
        }
            DocumentBuilder builder;
        try {
            builder = factory.newDocumentBuilder();

            return builder.parse(inputStream);
        } catch (Exception e) {
            throw new IOException(e.toString());
        }
    }
    
    public Document getDocument(){
        return document;
    }
}